PROGRAM PartySpiel (INPUT,OUTPUT);

{Diese Version ist in Standard - Pascal geschrieben.
Autoren: Jacob, Schupe}

CONST ganzgross= 1000;

TYPE    WunschFeld = ARRAY[1..10] OF INTEGER;

           GastTyp = RECORD
                              Name : CHAR;
                              x, y : INTEGER;
                     Wunschabstand : WunschFeld
                     END;


VAR     Gast                           : ARRAY[1..10] OF GastTyp;
        Nummer, Anzahl, xalt, yalt,
        Zimmerlaenge, Zimmerbreite     : INTEGER;
        Antwort                        : CHAR;


PROCEDURE erfrageZimmer;
BEGIN
     WRITE('Gib die Zimmerlaenge ein, hoechstens 78!  ');
     READLN(Zimmerlaenge);
     WRITE('Gib die Zimmerbreite ein, hoechstens 21!  ');
     READLN(Zimmerbreite);
     WRITELN;
END; {erfrageZimmer}


PROCEDURE erfrageGaeste;
VAR  dieser, jener : INTEGER;
BEGIN
   WRITE('Gib die Anzahl der Gaeste ein, aber hoechstens 10 ! ');
   READLN(Anzahl);
   WRITELN;
   FOR dieser := 1 TO Anzahl DO BEGIN
      WRITE('Gib den Anfangsbuchstaben des ', dieser:1,
                                       '. Gastes ein ! ');
      READLN(Gast[dieser].Name)
   END {FOR dieser};
   WRITELN;
   FOR dieser := 1 TO Anzahl DO
       FOR jener := 1 TO Anzahl DO
           IF dieser <> jener THEN WITH Gast[dieser] DO BEGIN
              WRITE('Welchen Abstand wuenscht ', Name,
                               ' von ', Gast[jener].Name,' ?  ');
              READLN(Wunschabstand[jener])
           END; {IF}
   WRITELN;
   WRITELN('Gib die Positionen der Gaeste ein !');
   FOR dieser := 1 TO Anzahl DO WITH Gast[dieser] DO BEGIN
      WRITE('Rechtswert von ',Name,' , hoechstens ',
             Zimmerlaenge:2 ,' : ');
      READLN(x);
      Write('  Hochwert von ',Name,' , hoechstens ',Zimmerbreite:2 ,
             ' : ');
      READLN(y)
   END; {FOR dieser}
   WRITELN
END; {erfrageGaeste}


FUNCTION imZimmer (x, y : INTEGER) : boolean;
BEGIN
     imZimmer := (0 < x) AND (x <= Zimmerlaenge) AND
                 (0 < y) AND (y <= Zimmerbreite)
END; {imZimmer}


FUNCTION BesetztFuer (dieser : INTEGER) : boolean;
VAR jener : INTEGER;
BEGIN
     BesetztFuer := FALSE;
     FOR jener := 1 TO Anzahl DO
         IF dieser <> jener THEN WITH Gast[dieser] DO
            IF (x = Gast[jener].x) AND
               (y = Gast[jener].y) THEN BesetztFuer := TRUE
END; {BesetztFuer}


FUNCTION Entfernung (dieser, jener : INTEGER) : REAL;
BEGIN
     Entfernung := sqrt(sqr(Gast[dieser].x - Gast[jener].x) +
               sqr(Gast[dieser].y - Gast[jener].y))
END; {FUNCTION Entfernung}


FUNCTION Missbehagen (dieser : INTEGER) : REAL;
VAR jener : INTEGER;
    Summe : REAL;
BEGIN
     Summe := 0;
     FOR jener := 1 TO Anzahl DO
         IF jener <> dieser THEN Summe := Summe +
            abs (Entfernung(dieser, jener)
                - Gast[dieser].Wunschabstand[jener]);
     Missbehagen := Summe
END; {FUNCTION Missbehagen}


PROCEDURE SuchePositionFuer(dieser : INTEGER);
VAR dx, dy, xneu, yneu   : INTEGER;
    kleinstesMissbehagen : REAL;
BEGIN
     kleinstesMissbehagen := ganzgross;
     WITH Gast[dieser] DO BEGIN
          xalt := x;
          yalt := y;
          FOR dx := -1 TO 1 DO
              FOR dy := -1 TO 1 DO BEGIN
                  x:= xalt + dx;
                  y:= yalt + dy;
                  IF imZimmer(x,y) AND NOT BesetztFuer(dieser) THEN
                     IF Missbehagen(dieser) < kleinstesMissbehagen
                     THEN BEGIN
                        kleinstesMissbehagen := Missbehagen(dieser);
                        xneu := x;
                        yneu := y
                     END {THEN}
              END; {FOR}
          x := xneu;
          y := yneu
     END {WITH}
END;


PROCEDURE zeigeZimmer;
VAR Spalte, Zeile, dieser : INTEGER;
    Zeichen               : CHAR;
BEGIN
   FOR Spalte := 0 TO Zimmerlaenge+1 DO WRITE('*');
   WRITELN;
   FOR Zeile := Zimmerbreite DOWNTO 1 DO BEGIN
      WRITE('*');
      FOR Spalte := 1 TO Zimmerlaenge DO BEGIN
         IF (xalt = Spalte) AND (yalt = Zeile) THEN Zeichen := '.'
                                               ELSE Zeichen := ' ';
         FOR dieser := 1 TO Anzahl DO WITH Gast[dieser] DO
            IF (x = Spalte) AND (y = Zeile) THEN Zeichen := Name;
         WRITE(Zeichen)
      END; {FOR Spalte}
      WRITELN('*')
   END; {FOR Zeile}
   FOR Spalte := 0 TO Zimmerlaenge+1 DO WRITE('*');
   WRITELN
END; {PROCEDURE zeigeZimmer}


PROCEDURE zeigeAnfang;
BEGIN
     xalt := 0;           { Es gibt noch keine alte Position. }
     yalt := 0;           { Deshalb wird sie ausserhalb des }
                          { Zimmers gesetzt. }
     zeigeZimmer;
     WRITE ('Anfangspositionen');
     WRITE('         weiter ---->  <RETURN> '); READLN
END; {zeigeAnfang}


PROCEDURE zeigePositionVon (dieser : INTEGER);
BEGIN
     zeigeZimmer;
     WRITE ('Bewegung von ', Gast[Nummer].Name);
     WRITE ('     Missbehagen : ', Missbehagen(dieser):3:1);
     WRITE ('         weiter ---->  <RETURN> '); READLN
END;  {zeigePositionVon}


BEGIN  {Party}
   erfrageZimmer;
   erfrageGaeste;
   zeigeAnfang;
   REPEAT
      FOR Nummer := 1 TO Anzahl DO BEGIN
          SuchePositionFuer(Nummer);
          zeigePositionVon (Nummer)
      END; {FOR Nummer}
      WRITE('Soll das Spiel beendet werden ?  j/n  ------>  ');
      READLN(Antwort)
   UNTIL (Antwort = 'j') OR (Antwort = 'J')
END. {Party}
