PROGRAM PartySpiel (INPUT,OUTPUT);

{ ------------------------------------------------- }
{ Diese Version ist fr TURBO PASCAL 5 geschrieben. }
{ Autoren: L.Schupe                                 }
{           Ulrich-von-Hutten-Oberschule            }
{           Rehagener Strae 35-37                  }
{           W-1000 Berlin 49                        }
{                                                   }
{           D.Jacob                                 }
{           Peter-A.-Silbermann-Schule              }
{           Blissestrae 22                         }
{           W-1000 Berlin 31                        }
{ ------------------------------------------------- }           

USES Crt;

CONST   ganzgross  = 1000;

TYPE    WunschFeld = ARRAY[1..10] OF integer;

        GastTyp    = RECORD
                       Name          : char;
                       x, y          : integer;
                       Wunschabstand : WunschFeld
                     END;


VAR     Gast                    : ARRAY[1..10] OF GastTyp;
        Nummer, Anzahl, xalt,
        yalt, Zimmerlaenge,
        Zimmerbreite, Zaehler   : integer;
        Antwort                 : char;


PROCEDURE erfrageZimmer;
BEGIN
     WRITE('Gib die Zimmerlaenge ein, hoechstens 77!  ');
     READLN(Zimmerlaenge);
     WRITE('Gib die Zimmerbreite ein, hoechstens 20!  ');
     READLN(Zimmerbreite);
     WRITELN;
END; {erfrageZimmer}


PROCEDURE erfrageGaeste;
VAR  dieser, jener : integer;
BEGIN
   WRITE('Gib die Anzahl der Gaeste ein, aber hoechstens 10 ! ');
   READLN(Anzahl);
   WRITELN;
   FOR dieser := 1 TO Anzahl DO BEGIN
      WRITE('Gib den Anfangsbuchstaben des ', dieser:1,
                                       '. Gastes ein ! ');
      READLN(Gast[dieser].Name)
   END {FOR dieser};
   WRITELN;
   FOR dieser := 1 TO Anzahl DO
       FOR jener := 1 TO Anzahl DO
           IF dieser <> jener THEN WITH Gast[dieser] DO BEGIN
              WRITE('Welchen Abstand wuenscht ', Name,
                               ' von ', Gast[jener].Name,' ?  ');
              READLN(Wunschabstand[jener])
           END; {IF}
   WRITELN;
   WRITELN('Gib die Positionen der Gaeste ein !');
   FOR dieser := 1 TO Anzahl DO WITH Gast[dieser] DO BEGIN
      WRITE('Rechtswert von ',Name,' , hoechstens ',
             Zimmerlaenge:2 ,' : ');
      READLN(x);
      WRITE('  Hochwert von ',Name,' , hoechstens ',Zimmerbreite:2 ,
             ' : ');
      READLN(y)
   END; {FOR dieser}
   WRITELN
END; {erfrageGaeste}


FUNCTION imZimmer (x, y : integer) : boolean;
BEGIN
     imZimmer := (0 < x) AND (x <= Zimmerlaenge) AND
                 (0 < y) AND (y <= Zimmerbreite)
END; {imZimmer}


FUNCTION BesetztFuer (dieser : integer) : boolean;
VAR jener : integer;
BEGIN
     BesetztFuer := false;
     FOR jener := 1 TO Anzahl DO 
         IF dieser <> jener THEN WITH Gast[dieser] DO
            IF (x = Gast[jener].x) AND
               (y = Gast[jener].y) THEN BesetztFuer := true
END; {BesetztFuer}


FUNCTION Entfernung (dieser, jener : integer) : real;
BEGIN
     Entfernung := sqrt(sqr(Gast[dieser].x - Gast[jener].x) +
                   sqr(Gast[dieser].y - Gast[jener].y))
END; {FUNCTION Entfernung}


FUNCTION Missbehagen (dieser : integer) : real;
VAR jener : integer;
    Summe : real;
BEGIN
     Summe := 0;
     FOR jener := 1 TO Anzahl DO
         IF jener <> dieser THEN
            Summe := Summe + abs (Entfernung(dieser, jener) -
                     Gast[dieser].Wunschabstand[jener]);
     Missbehagen := Summe
END; {FUNCTION Missbehagen}


PROCEDURE SuchePositionFuer(dieser : integer);
VAR dx, dy, xneu, yneu   : integer;
    kleinstesMissbehagen : real;
BEGIN
     kleinstesMissbehagen := ganzgross;
     WITH Gast[dieser] DO BEGIN
          xalt := x;
          yalt := y;
          FOR dx := -1 TO 1 DO
              FOR dy := -1 TO 1 DO
              BEGIN
                  x:= xalt + dx;
                  y:= yalt + dy;
                  IF imZimmer(x,y) AND NOT BesetztFuer(dieser) THEN
                     IF Missbehagen(dieser) < kleinstesMissbehagen
                     THEN
                     BEGIN
                        kleinstesMissbehagen := Missbehagen(dieser);
                        xneu := x;
                        yneu := y
                     END {THEN}
              END; {FOR}
          x := xneu;
          y := yneu
     END {WITH}
END;


PROCEDURE zeigeZimmer;
VAR Spalte, Zeile, dieser : integer;
    Zeichen               : char;
BEGIN
   ClrScr;
   Gotoxy(1,1);
   FOR Spalte := 1 TO Zimmerlaenge+2 DO WRITE('*');
   WRITELN;
   FOR Zeile := 2 TO Zimmerbreite+1 DO
      WRITELN('*', '*': Zimmerlaenge+1);
   FOR Spalte := 1 TO Zimmerlaenge+2 DO WRITE('*');
   WRITELN
END; {PROCEDURE zeigeZimmer}


PROCEDURE zeigeAnfang;
VAR dieser : integer;
BEGIN
     zeigeZimmer;
     FOR dieser := 1 TO Anzahl DO WITH Gast[dieser] DO
     BEGIN
         Gotoxy(x+1, y+1); write(Name)
     END; {FOR dieser}
     Gotoxy(1,24);
     WRITE ('Anfangspositionen');
     WRITE('         weiter ---->  <RETURN> '); READLN
END; {zeigeAnfang}


PROCEDURE zeigePositionVon (dieser : integer);
BEGIN
     Gotoxy(1,23);
     WRITE (' ':80);
     Gotoxy(xalt+1, yalt+1); write ('.');
     WITH Gast[dieser] DO
     BEGIN
          Gotoxy(x+1, y+1); write(Name)
     END {WITH}
END;  {zeigePositionVon}


PROCEDURE frageObWeiter;
BEGIN
      Gotoxy(1,23);
      WRITE('weiter ?    j/n   ');
      READLN(Antwort);
      Gotoxy(1,23);
      WRITE (' ':80)
END;


BEGIN  {Party}
   erfrageZimmer;
   erfrageGaeste;
   zeigeAnfang;
   REPEAT
      FOR Zaehler := 1 TO 20 DO
          FOR Nummer := 1 TO Anzahl DO
          BEGIN
              SuchePositionFuer(Nummer);
              zeigePositionVon (Nummer)
          END; {FOR Nummer}
      frageObWeiter
   UNTIL (Antwort = 'n') OR (Antwort = 'N')
END. {Party}
